<?php

// TIC TAC TOE Version 2.0
// 2006-09-16
// Brendan Ellis
// http://www.slayweb.com

// *** Settings ***
$gamename = "Tic Tac Toe";

// ****************


srand((double)microtime()*1000000);


function setsquare($val,$q,$p1,$p2,$p3,$p4,$p5,$p6,$p7,$p8,$p9) {
	switch($val) {
		case "x":
			echo "<td class=\"x\"></td>";
			break;
		case "o":
			echo "<td class=\"o\"></td>";
			break;
		case "b":
			echo "<td class=\"b\"><a href=\"";
			
			switch($q) {
				case 1:
					echo "./?newgame=no&p1=x&p2=".$p2."&p3=".$p3."&p4=".$p4."&p5=".$p5."&p6=".$p6."&p7=".$p7."&p8=".$p8."&p9=".$p9;
					break;
				case 2:
					echo "./?newgame=no&p1=".$p1."&p2=x&p3=".$p3."&p4=".$p4."&p5=".$p5."&p6=".$p6."&p7=".$p7."&p8=".$p8."&p9=".$p9;
					break;
				case 3:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=x&p4=".$p4."&p5=".$p5."&p6=".$p6."&p7=".$p7."&p8=".$p8."&p9=".$p9;
					break;
				case 4:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=".$p3."&p4=x&p5=".$p5."&p6=".$p6."&p7=".$p7."&p8=".$p8."&p9=".$p9;
					break;
				case 5:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=".$p3."&p4=".$p4."&p5=x&p6=".$p6."&p7=".$p7."&p8=".$p8."&p9=".$p9;
					break;
				case 6:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=".$p3."&p4=".$p4."&p5=".$p5."&p6=x&p7=".$p7."&p8=".$p8."&p9=".$p9;
					break;
				case 7:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=".$p3."&p4=".$p4."&p5=".$p5."&p6=".$p6."&p7=x&p8=".$p8."&p9=".$p9;
					break;
				case 8:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=".$p3."&p4=".$p4."&p5=".$p5."&p6=".$p6."&p7=".$p7."&p8=x&p9=".$p9;
					break;
				case 9:
					echo "./?newgame=no&p1=".$p1."&p2=".$p2."&p3=".$p3."&p4=".$p4."&p5=".$p5."&p6=".$p6."&p7=".$p7."&p8=".$p8."&p9=x";
					break;
			}


			echo "\"><img src=\"./images/blank.png\" /></a></td>";
			break;
		case "owh":
			echo "<td class=\"o\"><img src=\"./images/linehoriz.png\" /></td>";
			break;
		case "xwh":
			echo "<td class=\"x\"><img src=\"./images/linehoriz.png\" /></td>";
			break;
		case "owv":
			echo "<td class=\"o\"><img src=\"./images/linevert.png\" /></td>";
			break;
		case "xwv":
			echo "<td class=\"x\"><img src=\"./images/linevert.png\" /></td>";
			break;
		case "owld":
			echo "<td class=\"o\"><img src=\"./images/lineleftdown.png\" /></td>";
			break;
		case "xwld":
			echo "<td class=\"x\"><img src=\"./images/lineleftdown.png\" /></td>";
			break;
		case "owlu":
			echo "<td class=\"o\"><img src=\"./images/lineleftup.png\" /></td>";
			break;
		case "xwlu":
			echo "<td class=\"x\"><img src=\"./images/lineleftup.png\" /></td>";
			break;
		case "n":
			echo "<td class=\"b\"></td>";
			break;

		default:
			echo "<td>ERROR!</td>";
			break;
	}
}

function computergo(&$p1,&$p2,&$p3,&$p4,&$p5,&$p6,&$p7,&$p8,&$p9) {
	if (($p1=="o")&&($p2=="o")&&($p3=="b")):
		$p3 = "o";
	elseif (($p4=="o")&&($p5=="o")&&($p6=="b")):
		$p6 = "o";
	elseif (($p7=="o")&&($p8=="o")&&($p9=="b")):
		$p9 = "o";
	elseif (($p2=="o")&&($p3=="o")&&($p1=="b")):
		$p1 = "o";
	elseif (($p5=="o")&&($p6=="o")&&($p4=="b")):
		$p4 = "o";
	elseif (($p8=="o")&&($p9=="o")&&($p7=="b")):
		$p7 = "o";
	elseif (($p1=="o")&&($p4=="o")&&($p7=="b")):
		$p7 = "o";
	elseif (($p2=="o")&&($p5=="o")&&($p8=="b")):
		$p8 = "o";
	elseif (($p3=="o")&&($p6=="o")&&($p9=="b")):
		$p9 = "o";
	elseif (($p4=="o")&&($p7=="o")&&($p1=="b")):
		$p1 = "o";
	elseif (($p5=="o")&&($p8=="o")&&($p2=="b")):
		$p2 = "o";
	elseif (($p6=="o")&&($p9=="o")&&($p3=="b")):
		$p3 = "o";
	elseif (($p1=="o")&&($p5=="o")&&($p9=="b")):
		$p9 = "o";
	elseif (($p5=="o")&&($p9=="o")&&($p1=="b")):
		$p1 = "o";
	elseif (($p3=="o")&&($p5=="o")&&($p7=="b")):
		$p7 = "o";
	elseif (($p7=="o")&&($p5=="o")&&($p3=="b")):
		$p3 = "o";
	elseif (($p1=="o")&&($p3=="o")&&($p2=="b")):
		$p2 = "o";
	elseif (($p4=="o")&&($p6=="o")&&($p5=="b")):
		$p5 = "o";
	elseif (($p7=="o")&&($p9=="o")&&($p8=="b")):
		$p8 = "o";
	elseif (($p1=="o")&&($p7=="o")&&($p4=="b")):
		$p4 = "o";
	elseif (($p2=="o")&&($p8=="o")&&($p5=="b")):
		$p5 = "o";
	elseif (($p3=="o")&&($p9=="o")&&($p6=="b")):
		$p6 = "o";
	elseif (($p1=="o")&&($p9=="o")&&($p5=="b")):
		$p5 = "o";
	elseif (($p7=="o")&&($p3=="o")&&($p5=="b")):
		$p5 = "o";
	elseif (($p1=="x")&&($p2=="x")&&($p3=="b")):
		$p3 = "o";
	elseif (($p4=="x")&&($p5=="x")&&($p6=="b")):
		$p6 = "o";
	elseif (($p7=="x")&&($p8=="x")&&($p9=="b")):
		$p9 = "o";
	elseif (($p1=="x")&&($p4=="x")&&($p7=="b")):
		$p7 = "o";
	elseif (($p2=="x")&&($p5=="x")&&($p8=="b")):
		$p8 = "o";
	elseif (($p3=="x")&&($p6=="x")&&($p9=="b")):
		$p9 = "o";
	elseif (($p1=="x")&&($p5=="x")&&($p9=="b")):
		$p9 = "o";
	elseif (($p3=="x")&&($p5=="x")&&($p7=="b")):
		$p7 = "o";
	elseif (($p7=="x")&&($p5=="x")&&($p3=="b")):
		$p3 = "o";
	elseif (($p9=="x")&&($p5=="x")&&($p1=="b")):
		$p1 = "o";
	elseif (($p1=="x")&&($p7=="x")&&($p4=="b")):
		$p4 = "o";
	elseif (($p2=="x")&&($p8=="x")&&($p5=="b")):
		$p5 = "o";
	elseif (($p3=="x")&&($p9=="x")&&($p6=="b")):
		$p6 = "o";
	elseif (($p1=="x")&&($p3=="x")&&($p2=="b")):
		$p2 = "o";
	elseif (($p4=="x")&&($p6=="x")&&($p5=="b")):
		$p6 = "o";
	elseif (($p7=="x")&&($p9=="x")&&($p8=="b")):
		$p6 = "o";
	elseif (($p4=="x")&&($p5=="x")&&($p6=="b")):
		$p6 = "o";
	elseif (($p1=="x")&&($p9=="x")&&($p5=="b")):
		$p5 = "o";
	elseif (($p7=="x")&&($p3=="x")&&($p5=="b")):
		$p5 = "o";
	else:
		$found = 0;
		while ($found==0) {
			$num = rand(1,9);
			switch ($num) {
				case 1:
					if ($p1=="b") {
						$found = 1;
						$p1 = "o";
					}
					break;
				case 2:
					if ($p2=="b") {
						$found = 1;
						$p2 = "o";
					}
					break;
				case 3:
					if ($p3=="b") {
						$found = 1;
						$p3 = "o";
					}
					break;
				case 4:
					if ($p4=="b") {
						$found = 1;
						$p4 = "o";
					}
					break;
				case 5:
					if ($p5=="b") {
						$found = 1;
						$p5 = "o";
					}
					break;
				case 6:
					if ($p6=="b") {
						$found = 1;
						$p6 = "o";
					}
					break;
				case 7:
					if ($p7=="b") {
						$found = 1;
						$p7 = "o";
					}
					break;
				case 8:
					if ($p8=="b") {
						$found = 1;
						$p8 = "o";
					}
					break;
				case 9:
					if ($p9=="b") {
						$found = 1;
						$p9 = "o";
					}
					break;
			}
		}

	endif;

}

function checkwin($player,&$win,&$p1,&$p2,&$p3,&$p4,&$p5,&$p6,&$p7,&$p8,&$p9) {
	$win = 0;
	if (($p1==$player)&&($p2==$player)&&($p3==$player)):
		$p1 = $player."wh";
		$p2 = $player."wh";
		$p3 = $player."wh";
		$win = -1;
	elseif (($p4==$player)&&($p5==$player)&&($p6==$player)):
		$p4 = $player."wh";
		$p5 = $player."wh";
		$p6 = $player."wh";
		$win = -1;
	elseif (($p7==$player)&&($p8==$player)&&($p9==$player)):
		$p7 = $player."wh";
		$p8 = $player."wh";
		$p9 = $player."wh";
		$win = -1;
	elseif (($p1==$player)&&($p4==$player)&&($p7==$player)):
		$p1 = $player."wv";
		$p4 = $player."wv";
		$p7 = $player."wv";
		$win = -1;
	elseif (($p2==$player)&&($p5==$player)&&($p8==$player)):
		$p2 = $player."wv";
		$p5 = $player."wv";
		$p8 = $player."wv";
		$win = -1;
	elseif (($p3==$player)&&($p6==$player)&&($p9==$player)):
		$p3 = $player."wv";
		$p6 = $player."wv";
		$p9 = $player."wv";
		$win = -1;
	elseif (($p1==$player)&&($p5==$player)&&($p9==$player)):
		$p1 = $player."wld";
		$p5 = $player."wld";
		$p9 = $player."wld";
		$win = -1;
	elseif (($p7==$player)&&($p5==$player)&&($p3==$player)):
		$p7 = $player."wlu";
		$p5 = $player."wlu";
		$p3 = $player."wlu";
		$win = -1;
	elseif (($p1<>"b")&&($p2<>"b")&&($p3<>"b")&&($p4<>"b")&&($p5<>"b")&&($p6<>"b")&&($p7<>"b")&&($p8<>"b")&&($p9<>"b")):
		$win = 2;
	endif;


}

function blank2none(&$p1,&$p2,&$p3,&$p4,&$p5,&$p6,&$p7,&$p8,&$p9) {
	if ($p1=="b") 
		$p1="n";
	if ($p2=="b") 
		$p2="n";
	if ($p3=="b") 
		$p3="n";
	if ($p4=="b") 
		$p4="n";
	if ($p5=="b") 
		$p5="n";
	if ($p6=="b") 
		$p6="n";
	if ($p7=="b") 
		$p7="n";
	if ($p8=="b") 
		$p8="n";
	if ($p9=="b") 
		$p9="n";
}


// MAIN PROGRAM

$message = "";

import_request_variables("g","var_");

if (isset($var_newgame)) {
	checkwin("x",$won,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9);

	switch ($won) {
		case 0:
			computergo($var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9);
			checkwin("o",$cwon,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9);
			switch ($cwon) {
				case -1:
					blank2none($var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9);
					$message = "<div class=\"result\"><img src=\"./images/o.png\" height=\"50\" width=\"50\" /> &nbsp; WINS</div>";
					break;
				case 2:
					$message = "<div class=\"result\"><img src=\"./images/o.png\" height=\"50\" width=\"50\" /> &nbsp; GAME DRAWN &nbsp; <img src=\"./images/x.png\" height=\"50\" width=\"50\" /></div>";
					break;
			}
			break;
		case -1:
			blank2none($var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9);
    		$message = "<div class=\"result\"><img src=\"./images/x.png\" height=\"50\" width=\"50\" /> &nbsp; WINS</div>";
			break;
		case 2:
			$message = "<div class=\"result\"><img src=\"./images/x.png\" height=\"50\" width=\"50\" /> &nbsp; GAME DRAWN &nbsp; <img src=\"./images/o.png\" height=\"50\" width=\"50\" /></div>";
			break;
	}
} else {
	$var_p1 = "b";
	$var_p2 = "b";
	$var_p3 = "b";
	$var_p4 = "b";
	$var_p5 = "b";
	$var_p6 = "b";
	$var_p7 = "b";
	$var_p8 = "b";
	$var_p9 = "b";

	$rn = rand(1,2);
	if ($rn==1) {
    	computergo($var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9);
	}
}



?>

<html>
<head>
<title><?php echo $gamename; ?></title>
<link rel="stylesheet" type="text/css" href="./tictac.css" />
</head>
<body>

<h1><?php echo $gamename; ?></h1>

<table cellspacing="0" cellpadding="0" class="gametable">
 <tr>
  <?php setsquare($var_p1,1,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
  <td class="gridvert"></td>
  <?php setsquare($var_p2,2,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
  <td class="gridvert"></td>
  <?php setsquare($var_p3,3,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
 </tr>

 <tr>
  <td class="gridhoriz"></td>
  <td class="gridcross"></td>
  <td class="gridhoriz"></td>
  <td class="gridcross"></td>
  <td class="gridhoriz"></td>
 </tr>

 <tr>
  <?php setsquare($var_p4,4,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
  <td class="gridvert"></td>
  <?php setsquare($var_p5,5,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
  <td class="gridvert"></td>
  <?php setsquare($var_p6,6,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
 </tr>

 <tr>
  <td class="gridhoriz"></td>
  <td class="gridcross"></td>
  <td class="gridhoriz"></td>
  <td class="gridcross"></td>
  <td class="gridhoriz"></td>
 </tr>

 <tr>
  <?php setsquare($var_p7,7,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
  <td class="gridvert"></td>
  <?php setsquare($var_p8,8,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
  <td class="gridvert"></td>
  <?php setsquare($var_p9,9,$var_p1,$var_p2,$var_p3,$var_p4,$var_p5,$var_p6,$var_p7,$var_p8,$var_p9); ?>
 </tr>

</table>

<?php echo $message; ?>
<br />
<a class="newgame" href="./">New Game</a>

</body>
</html>
